/*
Copyright 2019 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	adminriocattleiov1 "github.com/rancher/rio/pkg/apis/admin.rio.cattle.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeFeatures implements FeatureInterface
type FakeFeatures struct {
	Fake *FakeAdminV1
	ns   string
}

var featuresResource = schema.GroupVersionResource{Group: "admin.rio.cattle.io", Version: "v1", Resource: "features"}

var featuresKind = schema.GroupVersionKind{Group: "admin.rio.cattle.io", Version: "v1", Kind: "Feature"}

// Get takes name of the feature, and returns the corresponding feature object, and an error if there is any.
func (c *FakeFeatures) Get(name string, options v1.GetOptions) (result *adminriocattleiov1.Feature, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(featuresResource, c.ns, name), &adminriocattleiov1.Feature{})

	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.Feature), err
}

// List takes label and field selectors, and returns the list of Features that match those selectors.
func (c *FakeFeatures) List(opts v1.ListOptions) (result *adminriocattleiov1.FeatureList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(featuresResource, featuresKind, c.ns, opts), &adminriocattleiov1.FeatureList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &adminriocattleiov1.FeatureList{ListMeta: obj.(*adminriocattleiov1.FeatureList).ListMeta}
	for _, item := range obj.(*adminriocattleiov1.FeatureList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested features.
func (c *FakeFeatures) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(featuresResource, c.ns, opts))

}

// Create takes the representation of a feature and creates it.  Returns the server's representation of the feature, and an error, if there is any.
func (c *FakeFeatures) Create(feature *adminriocattleiov1.Feature) (result *adminriocattleiov1.Feature, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(featuresResource, c.ns, feature), &adminriocattleiov1.Feature{})

	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.Feature), err
}

// Update takes the representation of a feature and updates it. Returns the server's representation of the feature, and an error, if there is any.
func (c *FakeFeatures) Update(feature *adminriocattleiov1.Feature) (result *adminriocattleiov1.Feature, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(featuresResource, c.ns, feature), &adminriocattleiov1.Feature{})

	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.Feature), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeFeatures) UpdateStatus(feature *adminriocattleiov1.Feature) (*adminriocattleiov1.Feature, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(featuresResource, "status", c.ns, feature), &adminriocattleiov1.Feature{})

	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.Feature), err
}

// Delete takes name of the feature and deletes it. Returns an error if one occurs.
func (c *FakeFeatures) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(featuresResource, c.ns, name), &adminriocattleiov1.Feature{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFeatures) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(featuresResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &adminriocattleiov1.FeatureList{})
	return err
}

// Patch applies the patch and returns the patched feature.
func (c *FakeFeatures) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *adminriocattleiov1.Feature, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(featuresResource, c.ns, name, pt, data, subresources...), &adminriocattleiov1.Feature{})

	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.Feature), err
}
