/*
Copyright 2019 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1

import (
	"time"

	v1 "github.com/rancher/rio/pkg/apis/autoscale.rio.cattle.io/v1"
	scheme "github.com/rancher/rio/pkg/generated/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ServiceScaleRecommendationsGetter has a method to return a ServiceScaleRecommendationInterface.
// A group's client should implement this interface.
type ServiceScaleRecommendationsGetter interface {
	ServiceScaleRecommendations(namespace string) ServiceScaleRecommendationInterface
}

// ServiceScaleRecommendationInterface has methods to work with ServiceScaleRecommendation resources.
type ServiceScaleRecommendationInterface interface {
	Create(*v1.ServiceScaleRecommendation) (*v1.ServiceScaleRecommendation, error)
	Update(*v1.ServiceScaleRecommendation) (*v1.ServiceScaleRecommendation, error)
	UpdateStatus(*v1.ServiceScaleRecommendation) (*v1.ServiceScaleRecommendation, error)
	Delete(name string, options *metav1.DeleteOptions) error
	DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error
	Get(name string, options metav1.GetOptions) (*v1.ServiceScaleRecommendation, error)
	List(opts metav1.ListOptions) (*v1.ServiceScaleRecommendationList, error)
	Watch(opts metav1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.ServiceScaleRecommendation, err error)
	ServiceScaleRecommendationExpansion
}

// serviceScaleRecommendations implements ServiceScaleRecommendationInterface
type serviceScaleRecommendations struct {
	client rest.Interface
	ns     string
}

// newServiceScaleRecommendations returns a ServiceScaleRecommendations
func newServiceScaleRecommendations(c *AutoscaleV1Client, namespace string) *serviceScaleRecommendations {
	return &serviceScaleRecommendations{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the serviceScaleRecommendation, and returns the corresponding serviceScaleRecommendation object, and an error if there is any.
func (c *serviceScaleRecommendations) Get(name string, options metav1.GetOptions) (result *v1.ServiceScaleRecommendation, err error) {
	result = &v1.ServiceScaleRecommendation{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ServiceScaleRecommendations that match those selectors.
func (c *serviceScaleRecommendations) List(opts metav1.ListOptions) (result *v1.ServiceScaleRecommendationList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.ServiceScaleRecommendationList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested serviceScaleRecommendations.
func (c *serviceScaleRecommendations) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a serviceScaleRecommendation and creates it.  Returns the server's representation of the serviceScaleRecommendation, and an error, if there is any.
func (c *serviceScaleRecommendations) Create(serviceScaleRecommendation *v1.ServiceScaleRecommendation) (result *v1.ServiceScaleRecommendation, err error) {
	result = &v1.ServiceScaleRecommendation{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		Body(serviceScaleRecommendation).
		Do().
		Into(result)
	return
}

// Update takes the representation of a serviceScaleRecommendation and updates it. Returns the server's representation of the serviceScaleRecommendation, and an error, if there is any.
func (c *serviceScaleRecommendations) Update(serviceScaleRecommendation *v1.ServiceScaleRecommendation) (result *v1.ServiceScaleRecommendation, err error) {
	result = &v1.ServiceScaleRecommendation{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		Name(serviceScaleRecommendation.Name).
		Body(serviceScaleRecommendation).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *serviceScaleRecommendations) UpdateStatus(serviceScaleRecommendation *v1.ServiceScaleRecommendation) (result *v1.ServiceScaleRecommendation, err error) {
	result = &v1.ServiceScaleRecommendation{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		Name(serviceScaleRecommendation.Name).
		SubResource("status").
		Body(serviceScaleRecommendation).
		Do().
		Into(result)
	return
}

// Delete takes name of the serviceScaleRecommendation and deletes it. Returns an error if one occurs.
func (c *serviceScaleRecommendations) Delete(name string, options *metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *serviceScaleRecommendations) DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched serviceScaleRecommendation.
func (c *serviceScaleRecommendations) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.ServiceScaleRecommendation, err error) {
	result = &v1.ServiceScaleRecommendation{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("servicescalerecommendations").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
